! Introduction to Fortran 95/2003 Exercise 1
program ex1_arrays
  implicit none
  integer, dimension(100,100) :: array_a, array_b, array_c
  integer :: i, j, nsum, iplus, iminus, jplus, jminus

  ! solution for exercise 1a

  array_a = 0
  array_a(50,:) = 1
  array_a(:,50) = 1

  do i = 1, 100
     write (*,'(100I1)') array_a(i,:)
  end do

  ! solution for exercise 1b

  do j = 2, 99
     do i = 2, 99
        ! determine the sum of neighboring elements
        nsum = array_a(i-1,j+1) + array_a(i-1,j) + array_a(i-1,j-1) + &
               array_a( i, j+1)                  + array_a( i, j-1) + &
               array_a(i+1,j+1) + array_a(i+1,j) + array_a(i+1,j-1)
        if (nsum == 2) then
           array_b(i,j) = array_a(i,j)
        else if (nsum == 3) then
           array_b(i,j) = 1
        else
           array_b(i,j) = 0
        end if
     end do
  end do

  write (*,*) ' ' 

  do i = 1, 100
     write (*,'(100I1)') array_b(i,:)
  end do

  ! solution for exercise 1c

  do j = 1, 100
     ! generate periodic boundaries
     jminus = j - 1
     jplus  = j + 1
     if (j == 1)   jminus = 100
     if (j == 100) jplus  = 1
     do i = 1, 100
        iminus = i - 1
        iplus  = i + 1
        if (i==1)   iminus = 100
        if (i==100) iplus  = 1
        ! determine the sum of neighboring elements
        nsum = array_a(iminus,jminus) + array_a(i,jminus) + array_a(iplus,jminus) + &
             & array_a(iminus,  j   ) +                     array_a(iplus,  j   ) + &
             & array_a(iminus,jplus ) + array_a(i,jplus ) + array_a(iplus,jplus )
        if (nsum == 2) then
           array_c(i,j) = array_a(i,j)
        else if (nsum == 3) then
           array_c(i,j) = 1
        else
           array_c(i,j) = 0
        end if
     end do
  end do

  write (*,*) ' ' 

  do i = 1, 100
     write (*,'(100I1)') array_c(i,:)
  end do
end program ex1_arrays
