! Fortran 95/2003 Exercise 3
program GameOfLife
  ! 2D cellular automaton ("Game of Life")
  ! (c) Pekka Manninen, Jussi Enkovaara, CSC - IT Center for Science Ltd
  use gol_io, only : read_data, draw
  implicit none
  integer, parameter :: &
       freq = 10           ! after how many iterations we print the board
  integer, dimension(:,:), pointer :: &
       board_1, board_2     ! GoL boards
  integer :: &
       height, width, &     ! board dimensions
       maxiter, i, &
       t0, t1, cnt, cnt_max

  ! read in the user input (iterations, board dimensions)
  call read_data(maxiter, height, width)
  ! initialize boards
  call init_board(board_1, board_2, height, width)
  ! develop the automaton
  call system_clock(t0, cnt, cnt_max)
  do i = 1, maxiter
     call update(board_1, board_2, height, width)
     if (mod(i,freq)==0) call draw(board_1, height, width, i)
  end do
  call system_clock(t1,cnt,cnt_max)
  write(*,'(A,I4,A,F6.2,A)') 'Completed ', maxiter, ' iterations in ', &
       real(t1-t0) / real(cnt), ' seconds.'

contains

  subroutine init_board(board_1, board_2, height, width)
  ! TODO: write a subroutine that initializes the GoL board(s)
  ! implement the plus-sign shaped pattern 
  ! (random starting configuration is an optional addition)
  end subroutine init_board

  subroutine update(board_1, board_2, heigth, width)
! TODO: write a subroutine that develops the automaton
! according to the Game of Life rules
  end subroutine update

end program GameOfLife
